/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/


extern rtx_insn *gen_split_1 (rtx_insn *, rtx *);




static int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern0 (x3, E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern0 (x3, E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern0 (x3, E_DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !nvptx_register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nvptx_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!nvptx_register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 3;

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

static int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!nvptx_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !nvptx_register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nvptx_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!nvptx_register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!nvptx_nonmemory_operand (operands[2], E_SImode))
    return -1;
  return pattern4 (x3); /* [-1, 2] */
}

static int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      return pattern0 (x3, E_BImode); /* [-1, 0] */

    case E_HImode:
      if (pattern0 (x3, E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern0 (x3, E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern0 (x3, E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

static int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode))
        return -1;
      return pattern7 (x3, E_SFmode); /* [-1, 1] */

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode))
        return -1;
      res = pattern7 (x3, E_DFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern9 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern9 (x3, E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern9 (x3, E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          return 0;

        case E_BImode:
          return 1;

        default:
          return -1;
        }

    case E_SImode:
      if (!nvptx_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!nvptx_nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 2;

        case E_HImode:
          if (!nvptx_nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 3;

        case E_BImode:
          if (!nvptx_register_operand (operands[1], E_BImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_DImode:
      if (!nvptx_register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!nvptx_nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 5;

        case E_HImode:
          if (!nvptx_nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 6;

        case E_SImode:
          if (!nvptx_nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 7;

        case E_BImode:
          if (!nvptx_register_operand (operands[1], E_BImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
pattern12 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern0 (x1, E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern0 (x1, E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern0 (x1, E_DImode) != 0)
        return -1;
      return 2;

    case E_SFmode:
      if (pattern0 (x1, E_SFmode) != 0)
        return -1;
      return 3;

    case E_DFmode:
      if (pattern0 (x1, E_DFmode) != 0)
        return -1;
      return 4;

    case E_HFmode:
      if (pattern12 (x1, E_HFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

static int
pattern14 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
      if (!nvptx_register_operand (x5, E_BImode))
        return -1;
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case LABEL_REF:
          x7 = XEXP (x2, 2);
          if (GET_CODE (x7) != PC)
            return -1;
          x8 = XEXP (x1, 0);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[0] = x5;
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          return 0;

        case CONST_INT:
        case CONST_DOUBLE:
        case REG:
          operands[2] = x6;
          x8 = XEXP (x1, 0);
          operands[0] = x8;
          operands[1] = x5;
          x7 = XEXP (x2, 2);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern14 (x2, E_HImode) != 0)
                return -1;
              return 1;

            case E_SImode:
              if (pattern14 (x2, E_SImode) != 0)
                return -1;
              return 2;

            case E_DImode:
              if (pattern14 (x2, E_DImode) != 0)
                return -1;
              return 3;

            case E_SFmode:
              if (pattern14 (x2, E_SFmode) != 0)
                return -1;
              return 4;

            case E_DFmode:
              if (pattern14 (x2, E_DFmode) != 0)
                return -1;
              return 5;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 19
          || GET_MODE (x5) != E_BImode)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != PC)
        return -1;
      x10 = XVECEXP (x5, 0, 0);
      operands[0] = x10;
      if (!nvptx_register_operand (operands[0], E_BImode))
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      return 6;

    default:
      return -1;
    }
}

static int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !nvptx_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nvptx_register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!nvptx_register_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!nvptx_register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

static int
pattern17 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern18 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern17 (x1, E_HImode, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern17 (x1, E_SImode, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern19 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_SImode:
      res = pattern19 (x1, E_SImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case E_DImode:
      res = pattern19 (x1, E_DImode);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 13)
    return -1;
  x3 = XEXP (x1, 0);
  operands[1] = x3;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[0] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!nvptx_register_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!nvptx_register_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern23 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x2, 1);
  operands[5] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern23 (x7, E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern23 (x7, E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern23 (x7, E_DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern25 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern23 (x1, E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern23 (x1, E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern23 (x1, E_DImode) != 0)
        return -1;
      return 2;

    case E_SFmode:
      if (pattern23 (x1, E_SFmode) != 0)
        return -1;
      return 3;

    case E_DFmode:
      if (pattern23 (x1, E_DFmode) != 0)
        return -1;
      return 4;

    case E_HFmode:
      if (pattern25 (x1, E_HFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

static int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x2, 1);
  operands[5] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  return pattern26 (x7); /* [-1, 5] */
}

static int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[0], E_HImode)
          || GET_MODE (x7) != E_HImode
          || !nvptx_register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nvptx_register_operand (operands[0], E_SImode)
          || GET_MODE (x7) != E_SImode
          || !nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!nvptx_register_operand (operands[0], E_DImode)
          || GET_MODE (x7) != E_DImode
          || !nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x7) != E_SFmode
          || !nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 3;

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x7) != E_DFmode
          || !nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

static int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x4, 1);
  operands[4] = x6;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!nvptx_register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !nvptx_register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nvptx_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!nvptx_register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x2, 1);
  operands[5] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  if (!nvptx_nonmemory_operand (operands[2], E_SImode))
    return -1;
  return pattern30 (x7); /* [-1, 2] */
}

static int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x2, 1);
  operands[5] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      return pattern23 (x7, E_BImode); /* [-1, 0] */

    case E_HImode:
      if (pattern23 (x7, E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern23 (x7, E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern23 (x7, E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

static int
pattern33 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode))
        return -1;
      return pattern33 (x7, E_SFmode); /* [-1, 1] */

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode))
        return -1;
      res = pattern33 (x7, E_DFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern35 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern35 (x7, E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern35 (x7, E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern37 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern38 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  switch (XWINT (x8, 0))
    {
    case 16L:
      return pattern37 (x1, E_HImode, E_SImode); /* [-1, 0] */

    case 32L:
      if (pattern37 (x1, E_SImode, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern39 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_double_operand (operands[2], i1)
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  return 0;
}

static int
pattern40 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern41 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern42 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern43 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || !nvptx_float_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[2], E_SFmode)
          || !nvptx_nonmemory_operand (operands[3], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[2], E_DFmode)
          || !nvptx_nonmemory_operand (operands[3], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern44 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || !nvptx_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[2], E_HImode)
          || !nvptx_nonmemory_operand (operands[3], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nvptx_register_operand (operands[2], E_SImode)
          || !nvptx_nonmemory_operand (operands[3], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!nvptx_register_operand (operands[2], E_DImode)
          || !nvptx_nonmemory_operand (operands[3], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern45 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_nonmemory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[4] = x5;
  x6 = XEXP (x5, 0);
  operands[5] = x6;
  x7 = XEXP (x5, 1);
  operands[6] = x7;
  if (!nvptx_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  if (!nvptx_register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x4, 1);
  operands[2] = x9;
  if (!nvptx_register_operand (operands[2], E_SImode))
    return -1;
  x10 = XEXP (x3, 1);
  operands[3] = x10;
  if (!nvptx_register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

static int
pattern47 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  return 0;
}

static int
pattern48 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x6) != E_SFmode
          || !nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x6) != E_DFmode
          || !nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_SImode:
      res = pattern48 (x6, E_SImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case E_DImode:
      res = pattern48 (x6, E_DImode);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x6) != E_SFmode
          || !nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x6) != E_DFmode
          || !nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          return 0;

        case E_BImode:
          return 1;

        default:
          return -1;
        }

    case E_SImode:
      if (!nvptx_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!nvptx_nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 2;

        case E_HImode:
          if (!nvptx_nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 3;

        case E_BImode:
          if (!nvptx_register_operand (operands[1], E_BImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_DImode:
      if (!nvptx_register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!nvptx_nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 5;

        case E_HImode:
          if (!nvptx_nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 6;

        case E_SImode:
          if (!nvptx_nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 7;

        case E_BImode:
          if (!nvptx_register_operand (operands[1], E_BImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
pattern52 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern53 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern52 (x1, E_HImode, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern52 (x1, E_SImode, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern54 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_register_operand (operands[0], i1))
    return -1;
  return 0;
}

static int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      return pattern54 (x1, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern54 (x1, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern56 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern57 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!nvptx_register_operand (operands[1], E_BImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern56 (x1, E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern56 (x1, E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern56 (x1, E_DImode) != 0)
        return -1;
      return 2;

    case E_SFmode:
      if (pattern56 (x1, E_SFmode) != 0)
        return -1;
      return 3;

    case E_DFmode:
      if (pattern56 (x1, E_DFmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

static int
pattern58 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern59 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern60 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  switch (XWINT (x8, 0))
    {
    case 16L:
      return pattern59 (x1, E_HImode, E_SImode); /* [-1, 0] */

    case 32L:
      if (pattern59 (x1, E_SImode, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern61 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_double_operand (operands[2], i1)
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  return 0;
}

static int
pattern62 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern63 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern64 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern65 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || !nvptx_float_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[2], E_SFmode)
          || !nvptx_nonmemory_operand (operands[3], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[2], E_DFmode)
          || !nvptx_nonmemory_operand (operands[3], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern66 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || !nvptx_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[2], E_HImode)
          || !nvptx_nonmemory_operand (operands[3], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nvptx_register_operand (operands[2], E_SImode)
          || !nvptx_nonmemory_operand (operands[3], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!nvptx_register_operand (operands[2], E_DImode)
          || !nvptx_nonmemory_operand (operands[3], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern67 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_nonmemory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern68 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  return 0;
}

static int
pattern69 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

static int
pattern70 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_register_operand (operands[0], i1))
    return -1;
  return 0;
}

static int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      return pattern70 (x1, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern70 (x1, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern72 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern73 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

static int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_CODE (x2))
    {
    case EQ:
      switch (pattern4 (x2))
        {
        case 0:
          return 88; /* *cnothi2 */

        case 1:
          return 89; /* *cnotsi2 */

        case 2:
          return 90; /* *cnotdi2 */

        default:
          return -1;
        }

    case NE:
      if (!nvptx_register_operand (operands[1], E_BImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!nvptx_register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode)
            return -1;
          return 136; /* setcchi_from_bi */

        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          return 137; /* setccsi_from_bi */

        case E_DImode:
          if (!nvptx_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          return 138; /* setccdi_from_bi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
    {
      res = recog_1 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[1] = x2;
  x4 = XEXP (x2, 0);
  operands[2] = x4;
  operands[3] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      switch (pattern43 (E_BImode))
        {
        case 0:
          return 129; /* *cmpsf */

        case 1:
          return 130; /* *cmpdf */

        default:
          return -1;
        }

    case E_SFmode:
      switch (pattern43 (E_SFmode))
        {
        case 0:
          return 158; /* setcc_floatsf */

        case 1:
          return 159; /* setcc_floatdf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 0:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!nvptx_register_operand (operands[0], E_QImode)
                  || GET_MODE (x3) != E_QImode)
                return -1;
              return 11; /* load_arg_regqi */

            case E_HImode:
              if (!nvptx_register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode)
                return -1;
              return 12; /* load_arg_reghi */

            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              return 13; /* load_arg_regsi */

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              return 14; /* load_arg_regdi */

            case E_SFmode:
              if (!nvptx_register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode)
                return -1;
              return 15; /* load_arg_regsf */

            case E_DFmode:
              if (!nvptx_register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode)
                return -1;
              return 16; /* load_arg_regdf */

            default:
              return -1;
            }

        case 11:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !nvptx_register_operand (operands[1], E_SImode))
                return -1;
              return 91; /* bitrevsi2 */

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !nvptx_register_operand (operands[1], E_DImode))
                return -1;
              return 92; /* bitrevdi2 */

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x3) != E_SFmode
              || !nvptx_register_operand (operands[0], E_SFmode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!nvptx_register_operand (operands[1], E_SFmode)
              || !
#line 1112 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 188; /* sinsf2 */

        case 5:
          if (GET_MODE (x3) != E_SFmode
              || !nvptx_register_operand (operands[0], E_SFmode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!nvptx_register_operand (operands[1], E_SFmode)
              || !
#line 1119 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 189; /* cossf2 */

        case 2:
          if (GET_MODE (x3) != E_SFmode
              || !nvptx_register_operand (operands[0], E_SFmode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!nvptx_register_operand (operands[1], E_SFmode)
              || !
#line 1126 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 190; /* log2sf2 */

        case 3:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!nvptx_register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode
                  || !nvptx_register_operand (operands[1], E_SFmode)
                  || !
#line 1133 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 191; /* exp2sf2 */

            case E_HFmode:
              if (!nvptx_register_operand (operands[0], E_HFmode)
                  || GET_MODE (x3) != E_HFmode
                  || !nvptx_register_operand (operands[1], E_HFmode)
                  || !
#line 1163 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM75 && flag_unsafe_math_optimizations))
                return -1;
              return 195; /* exp2hf2 */

            default:
              return -1;
            }

        case 6:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_HFmode:
              if (!nvptx_register_operand (operands[0], E_HFmode)
                  || GET_MODE (x3) != E_HFmode
                  || !nvptx_register_operand (operands[1], E_HFmode)
                  || !
#line 1170 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM75 && flag_unsafe_math_optimizations))
                return -1;
              return 196; /* tanhhf2 */

            case E_SFmode:
              if (!nvptx_register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode
                  || !nvptx_register_operand (operands[1], E_SFmode)
                  || !
#line 1170 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM75 && flag_unsafe_math_optimizations))
                return -1;
              return 197; /* tanhsf2 */

            default:
              return -1;
            }

        case 7:
          switch (pattern20 (x3))
            {
            case 0:
              return 218; /* floorsf2 */

            case 1:
              return 222; /* floordf2 */

            case 2:
              return 226; /* lfloorsfsi2 */

            case 3:
              return 228; /* lfloordfsi2 */

            case 4:
              return 230; /* lfloorsfdi2 */

            case 5:
              return 232; /* lfloordfdi2 */

            default:
              return -1;
            }

        case 8:
          switch (pattern21 (x3))
            {
            case 0:
              return 219; /* btruncsf2 */

            case 1:
              return 223; /* btruncdf2 */

            default:
              return -1;
            }

        case 9:
          switch (pattern20 (x3))
            {
            case 0:
              return 220; /* ceilsf2 */

            case 1:
              return 224; /* ceildf2 */

            case 2:
              return 227; /* lceilsfsi2 */

            case 3:
              return 229; /* lceildfsi2 */

            case 4:
              return 231; /* lceilsfdi2 */

            case 5:
              return 233; /* lceildfdi2 */

            default:
              return -1;
            }

        case 10:
          switch (pattern21 (x3))
            {
            case 0:
              return 221; /* nearbyintsf2 */

            case 1:
              return 225; /* nearbyintdf2 */

            default:
              return -1;
            }

        case 14:
          if (GET_MODE (x3) != E_SImode
              || !nvptx_register_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          return 257; /* oacc_dim_size */

        case 16:
          if (GET_MODE (x3) != E_SImode
              || !nvptx_register_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!nvptx_register_operand (operands[1], E_BImode))
            return -1;
          return 265; /* nvptx_vote_ballot */

        case 17:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !nvptx_register_operand (operands[0], E_SImode))
            return -1;
          return 270; /* omp_simt_lane */

        default:
          return -1;
        }

    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (XINT (x3, 1))
        {
        case 1:
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern41 (x3, E_SFmode) != 0)
                return -1;
              return 176; /* copysignsf3 */

            case E_DFmode:
              if (pattern41 (x3, E_DFmode) != 0)
                return -1;
              return 177; /* copysigndf3 */

            default:
              return -1;
            }

        case 15:
          if (!nvptx_register_operand (operands[1], E_SImode)
              || !nvptx_register_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              return 273; /* packsidi2 */

            case E_DFmode:
              if (!nvptx_register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode)
                return -1;
              return 274; /* packsidf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      if (XINT (x3, 1) != 18)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!nvptx_nonmemory_operand (operands[2], E_SImode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !nvptx_register_operand (operands[1], E_SImode))
            return -1;
          return 263; /* nvptx_shufflesi */

        case E_SFmode:
          if (!nvptx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !nvptx_register_operand (operands[1], E_SFmode))
            return -1;
          return 264; /* nvptx_shufflesf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      if (nvptx_register_operand (operands[0], E_BImode)
          && nvptx_nonmemory_operand (operands[1], E_BImode))
        return 1; /* movbi */
      break;

    case E_V2SImode:
      if (nonimmediate_operand (operands[0], E_V2SImode)
          && general_operand (operands[1], E_V2SImode)
          && 
#line 228 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return 2; /* *movv2si_insn */
      break;

    case E_V2DImode:
      if (nonimmediate_operand (operands[0], E_V2DImode)
          && general_operand (operands[1], E_V2DImode)
          && 
#line 228 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return 3; /* *movv2di_insn */
      break;

    case E_QImode:
      if (nonimmediate_operand (operands[0], E_QImode)
          && general_operand (operands[1], E_QImode)
          && 
#line 242 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return 4; /* *movqi_insn */
      break;

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && general_operand (operands[1], E_HImode)
          && 
#line 242 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return 5; /* *movhi_insn */
      break;

    case E_SImode:
      if (nonimmediate_operand (operands[0], E_SImode)
          && general_operand (operands[1], E_SImode)
          && 
#line 242 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return 6; /* *movsi_insn */
      break;

    case E_DImode:
      if (nonimmediate_operand (operands[0], E_DImode)
          && general_operand (operands[1], E_DImode)
          && 
#line 242 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return 7; /* *movdi_insn */
      break;

    case E_SFmode:
      if (nonimmediate_operand (operands[0], E_SFmode)
          && general_operand (operands[1], E_SFmode)
          && 
#line 267 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return 8; /* *movsf_insn */
      break;

    case E_DFmode:
      if (nonimmediate_operand (operands[0], E_DFmode)
          && general_operand (operands[1], E_DFmode)
          && 
#line 267 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return 9; /* *movdf_insn */
      break;

    case E_HFmode:
      if (nonimmediate_operand (operands[0], E_HFmode)
          && nonimmediate_operand (operands[1], E_HFmode)
          && 
#line 281 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return 10; /* *movhf_insn */
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != LABEL_REF
      || GET_CODE (x3) != PC)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  return 131; /* jump */
}

static int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_QImode)
        return -1;
      operands[2] = x1;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!call_insn_operand (operands[0], E_SImode)
              || !
#line 208 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
            return -1;
          return 160; /* call_insn_si */

        case E_DImode:
          if (!call_insn_operand (operands[0], E_DImode)
              || !
#line 208 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
            return -1;
          return 161; /* call_insn_di */

        default:
          return -1;
        }

    case SET:
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != CALL)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_QImode)
        return -1;
      operands[3] = x1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (!nvptx_register_operand (operands[0], E_VOIDmode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!call_insn_operand (operands[1], E_SImode)
              || !
#line 208 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
            return -1;
          return 162; /* call_value_insn_si */

        case E_DImode:
          if (!call_insn_operand (operands[1], E_DImode)
              || !
#line 208 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
            return -1;
          return 163; /* call_value_insn_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      if (!nvptx_register_operand (operands[0], E_BImode)
          || !nvptx_nonmemory_operand (operands[1], E_BImode))
        return -1;
      return 342; /* *p movbi */

    case E_V2SImode:
      if (!nonimmediate_operand (operands[0], E_V2SImode)
          || !general_operand (operands[1], E_V2SImode)
          || !
#line 228 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 343; /* *p *movv2si_insn */

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || !general_operand (operands[1], E_V2DImode)
          || !
#line 228 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 344; /* *p *movv2di_insn */

    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !general_operand (operands[1], E_QImode)
          || !
#line 242 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 345; /* *p *movqi_insn */

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !general_operand (operands[1], E_HImode)
          || !
#line 242 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 346; /* *p *movhi_insn */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !general_operand (operands[1], E_SImode)
          || !
#line 242 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 347; /* *p *movsi_insn */

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !general_operand (operands[1], E_DImode)
          || !
#line 242 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 348; /* *p *movdi_insn */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !general_operand (operands[1], E_SFmode)
          || !
#line 267 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 349; /* *p *movsf_insn */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !general_operand (operands[1], E_DFmode)
          || !
#line 267 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 350; /* *p *movdf_insn */

    case E_HFmode:
      if (!nonimmediate_operand (operands[0], E_HFmode)
          || !nonimmediate_operand (operands[1], E_HFmode)
          || !
#line 281 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 351; /* *p *movhf_insn */

    default:
      return -1;
    }
}

static int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  switch (GET_CODE (x6))
    {
    case EQ:
      switch (pattern30 (x6))
        {
        case 0:
          return 429; /* *p *cnothi2 */

        case 1:
          return 430; /* *p *cnotsi2 */

        case 2:
          return 431; /* *p *cnotdi2 */

        default:
          return -1;
        }

    case NE:
      if (!nvptx_register_operand (operands[1], E_BImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!nvptx_register_operand (operands[0], E_HImode)
              || GET_MODE (x6) != E_HImode)
            return -1;
          return 473; /* *p setcchi_from_bi */

        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode)
            return -1;
          return 474; /* *p setccsi_from_bi */

        case E_DImode:
          if (!nvptx_register_operand (operands[0], E_DImode)
              || GET_MODE (x6) != E_DImode)
            return -1;
          return 475; /* *p setccdi_from_bi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
    {
      res = recog_7 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[1] = x3;
  x5 = XEXP (x1, 0);
  operands[4] = x5;
  x6 = XEXP (x5, 0);
  operands[5] = x6;
  x7 = XEXP (x5, 1);
  operands[6] = x7;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      switch (pattern65 (E_BImode))
        {
        case 0:
          return 470; /* *p *cmpsf */

        case 1:
          return 471; /* *p *cmpdf */

        default:
          return -1;
        }

    case E_SFmode:
      switch (pattern65 (E_SFmode))
        {
        case 0:
          return 495; /* *p setcc_floatsf */

        case 1:
          return 496; /* *p setcc_floatdf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      switch (XINT (x4, 1))
        {
        case 0:
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!nvptx_register_operand (operands[0], E_QImode)
                  || GET_MODE (x4) != E_QImode)
                return -1;
              return 352; /* *p load_arg_regqi */

            case E_HImode:
              if (!nvptx_register_operand (operands[0], E_HImode)
                  || GET_MODE (x4) != E_HImode)
                return -1;
              return 353; /* *p load_arg_reghi */

            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode)
                return -1;
              return 354; /* *p load_arg_regsi */

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x4) != E_DImode)
                return -1;
              return 355; /* *p load_arg_regdi */

            case E_SFmode:
              if (!nvptx_register_operand (operands[0], E_SFmode)
                  || GET_MODE (x4) != E_SFmode)
                return -1;
              return 356; /* *p load_arg_regsf */

            case E_DFmode:
              if (!nvptx_register_operand (operands[0], E_DFmode)
                  || GET_MODE (x4) != E_DFmode)
                return -1;
              return 357; /* *p load_arg_regdf */

            default:
              return -1;
            }

        case 11:
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode
                  || !nvptx_register_operand (operands[1], E_SImode))
                return -1;
              return 432; /* *p bitrevsi2 */

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x4) != E_DImode
                  || !nvptx_register_operand (operands[1], E_DImode))
                return -1;
              return 433; /* *p bitrevdi2 */

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x4) != E_SFmode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          if (!nvptx_register_operand (operands[0], E_SFmode))
            return -1;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          if (!nvptx_register_operand (operands[1], E_SFmode)
              || !
#line 1112 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 525; /* *p sinsf2 */

        case 5:
          if (GET_MODE (x4) != E_SFmode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          if (!nvptx_register_operand (operands[0], E_SFmode))
            return -1;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          if (!nvptx_register_operand (operands[1], E_SFmode)
              || !
#line 1119 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 526; /* *p cossf2 */

        case 2:
          if (GET_MODE (x4) != E_SFmode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          if (!nvptx_register_operand (operands[0], E_SFmode))
            return -1;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          if (!nvptx_register_operand (operands[1], E_SFmode)
              || !
#line 1126 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 527; /* *p log2sf2 */

        case 3:
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!nvptx_register_operand (operands[0], E_SFmode)
                  || GET_MODE (x4) != E_SFmode
                  || !nvptx_register_operand (operands[1], E_SFmode)
                  || !
#line 1133 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 528; /* *p exp2sf2 */

            case E_HFmode:
              if (!nvptx_register_operand (operands[0], E_HFmode)
                  || GET_MODE (x4) != E_HFmode
                  || !nvptx_register_operand (operands[1], E_HFmode)
                  || !
#line 1163 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM75 && flag_unsafe_math_optimizations))
                return -1;
              return 532; /* *p exp2hf2 */

            default:
              return -1;
            }

        case 6:
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_HFmode:
              if (!nvptx_register_operand (operands[0], E_HFmode)
                  || GET_MODE (x4) != E_HFmode
                  || !nvptx_register_operand (operands[1], E_HFmode)
                  || !
#line 1170 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM75 && flag_unsafe_math_optimizations))
                return -1;
              return 533; /* *p tanhhf2 */

            case E_SFmode:
              if (!nvptx_register_operand (operands[0], E_SFmode)
                  || GET_MODE (x4) != E_SFmode
                  || !nvptx_register_operand (operands[1], E_SFmode)
                  || !
#line 1170 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM75 && flag_unsafe_math_optimizations))
                return -1;
              return 534; /* *p tanhsf2 */

            default:
              return -1;
            }

        case 7:
          switch (pattern49 (x1))
            {
            case 0:
              return 555; /* *p floorsf2 */

            case 1:
              return 559; /* *p floordf2 */

            case 2:
              return 563; /* *p lfloorsfsi2 */

            case 3:
              return 565; /* *p lfloordfsi2 */

            case 4:
              return 567; /* *p lfloorsfdi2 */

            case 5:
              return 569; /* *p lfloordfdi2 */

            default:
              return -1;
            }

        case 8:
          switch (pattern50 (x1))
            {
            case 0:
              return 556; /* *p btruncsf2 */

            case 1:
              return 560; /* *p btruncdf2 */

            default:
              return -1;
            }

        case 9:
          switch (pattern49 (x1))
            {
            case 0:
              return 557; /* *p ceilsf2 */

            case 1:
              return 561; /* *p ceildf2 */

            case 2:
              return 564; /* *p lceilsfsi2 */

            case 3:
              return 566; /* *p lceildfsi2 */

            case 4:
              return 568; /* *p lceilsfdi2 */

            case 5:
              return 570; /* *p lceildfdi2 */

            default:
              return -1;
            }

        case 10:
          switch (pattern50 (x1))
            {
            case 0:
              return 558; /* *p nearbyintsf2 */

            case 1:
              return 562; /* *p nearbyintdf2 */

            default:
              return -1;
            }

        case 14:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          if (!nvptx_register_operand (operands[0], E_SImode))
            return -1;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          return 591; /* *p oacc_dim_size */

        case 16:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          if (!nvptx_register_operand (operands[0], E_SImode))
            return -1;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          if (!nvptx_register_operand (operands[1], E_BImode))
            return -1;
          return 595; /* *p nvptx_vote_ballot */

        case 17:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x8 = XVECEXP (x4, 0, 0);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XEXP (x1, 0);
          operands[1] = x5;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          x7 = XEXP (x5, 1);
          operands[3] = x7;
          if (!nvptx_register_operand (operands[0], E_SImode))
            return -1;
          return 600; /* *p omp_simt_lane */

        default:
          return -1;
        }

    case 2:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      x8 = XVECEXP (x4, 0, 0);
      operands[1] = x8;
      x9 = XVECEXP (x4, 0, 1);
      operands[2] = x9;
      switch (XINT (x4, 1))
        {
        case 1:
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern63 (x4, E_SFmode) != 0)
                return -1;
              return 513; /* *p copysignsf3 */

            case E_DFmode:
              if (pattern63 (x4, E_DFmode) != 0)
                return -1;
              return 514; /* *p copysigndf3 */

            default:
              return -1;
            }

        case 15:
          if (!nvptx_register_operand (operands[1], E_SImode)
              || !nvptx_register_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x4) != E_DImode)
                return -1;
              return 603; /* *p packsidi2 */

            case E_DFmode:
              if (!nvptx_register_operand (operands[0], E_DFmode)
                  || GET_MODE (x4) != E_DFmode)
                return -1;
              return 604; /* *p packsidf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      if (XINT (x4, 1) != 18)
        return -1;
      x5 = XEXP (x1, 0);
      operands[4] = x5;
      x6 = XEXP (x5, 0);
      operands[5] = x6;
      x7 = XEXP (x5, 1);
      operands[6] = x7;
      x8 = XVECEXP (x4, 0, 0);
      operands[1] = x8;
      x9 = XVECEXP (x4, 0, 1);
      operands[2] = x9;
      if (!nvptx_nonmemory_operand (operands[2], E_SImode))
        return -1;
      x10 = XVECEXP (x4, 0, 2);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !nvptx_register_operand (operands[1], E_SImode))
            return -1;
          return 593; /* *p nvptx_shufflesi */

        case E_SFmode:
          if (!nvptx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x4) != E_SFmode
              || !nvptx_register_operand (operands[1], E_SFmode))
            return -1;
          return 594; /* *p nvptx_shufflesf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x3))
    {
    case CALL:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_QImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      operands[2] = x2;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      x9 = XEXP (x3, 1);
      operands[1] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!call_insn_operand (operands[0], E_SImode)
              || !
#line 208 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
            return -1;
          return 497; /* *p call_insn_si */

        case E_DImode:
          if (!call_insn_operand (operands[0], E_DImode)
              || !
#line 208 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
            return -1;
          return 498; /* *p call_insn_di */

        default:
          return -1;
        }

    case SET:
      x9 = XEXP (x3, 1);
      if (GET_CODE (x9) != CALL)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != MEM
          || GET_MODE (x10) != E_QImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[4] = x5;
      x6 = XEXP (x5, 0);
      operands[5] = x6;
      x7 = XEXP (x5, 1);
      operands[6] = x7;
      operands[3] = x2;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (!nvptx_register_operand (operands[0], E_VOIDmode))
        return -1;
      x11 = XEXP (x10, 0);
      operands[1] = x11;
      x12 = XEXP (x9, 1);
      operands[2] = x12;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!call_insn_operand (operands[1], E_SImode)
              || !
#line 208 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
            return -1;
          return 499; /* *p call_value_insn_si */

        case E_DImode:
          if (!call_insn_operand (operands[1], E_DImode)
              || !
#line 208 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
            return -1;
          return 500; /* *p call_value_insn_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      res = recog_6 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x3) != LABEL_REF)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x1, 0);
      operands[1] = x5;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      x8 = XEXP (x3, 0);
      operands[0] = x8;
      return 472; /* *p jump */

    case UNSPEC:
      return recog_9 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (pattern51 (x3))
        {
        case 0:
          if (!nvptx_nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 358; /* *p zero_extendqihi2 */

        case 1:
          if (!nvptx_register_operand (operands[1], E_BImode))
            return -1;
          return 479; /* *p zero_extendbihi2 */

        case 2:
          return 359; /* *p zero_extendqisi2 */

        case 3:
          return 360; /* *p zero_extendhisi2 */

        case 4:
          return 480; /* *p zero_extendbisi2 */

        case 5:
          return 361; /* *p zero_extendqidi2 */

        case 6:
          return 362; /* *p zero_extendhidi2 */

        case 7:
          return 363; /* *p zero_extendsidi2 */

        case 8:
          return 481; /* *p zero_extendbidi2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case MEM:
          switch (pattern51 (x3))
            {
            case 0:
              if (!nvptx_register_operand (operands[1], E_QImode))
                return -1;
              return 364; /* *p extendqihi2 */

            case 1:
              if (!nvptx_register_operand (operands[1], E_BImode))
                return -1;
              return 476; /* *p extendbihi2 */

            case 2:
              return 365; /* *p extendqisi2 */

            case 3:
              return 366; /* *p extendhisi2 */

            case 4:
              return 477; /* *p extendbisi2 */

            case 5:
              return 367; /* *p extendqidi2 */

            case 6:
              return 368; /* *p extendhidi2 */

            case 7:
              return 369; /* *p extendsidi2 */

            case 8:
              return 478; /* *p extendbidi2 */

            default:
              return -1;
            }

        case TRUNCATE:
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!nvptx_register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || GET_MODE (x8) != E_QImode
                  || !nvptx_register_operand (operands[1], E_HImode))
                return -1;
              return 376; /* *p *extend_trunc_hi2_qi */

            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !nvptx_register_operand (operands[1], E_SImode))
                return -1;
              switch (GET_MODE (x8))
                {
                case E_QImode:
                  return 377; /* *p *extend_trunc_si2_qi */

                case E_HImode:
                  return 379; /* *p *extend_trunc_si2_hi */

                default:
                  return -1;
                }

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !nvptx_register_operand (operands[1], E_DImode))
                return -1;
              switch (GET_MODE (x8))
                {
                case E_QImode:
                  return 378; /* *p *extend_trunc_di2_qi */

                case E_HImode:
                  return 380; /* *p *extend_trunc_di2_hi */

                case E_SImode:
                  return 381; /* *p *extend_trunc_di2_si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case REG:
          operands[1] = x8;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!nvptx_nonimmediate_operand (operands[0], E_QImode)
                  || GET_MODE (x3) != E_QImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_HImode:
                  if (!nvptx_register_operand (operands[1], E_HImode))
                    return -1;
                  return 370; /* *p trunchiqi2 */

                case E_SImode:
                  if (!nvptx_register_operand (operands[1], E_SImode))
                    return -1;
                  return 371; /* *p truncsiqi2 */

                case E_DImode:
                  if (!nvptx_register_operand (operands[1], E_DImode))
                    return -1;
                  return 373; /* *p truncdiqi2 */

                default:
                  return -1;
                }

            case E_HImode:
              if (!nvptx_nonimmediate_operand (operands[0], E_HImode))
                return -1;
              switch (pattern33 (x3, E_HImode))
                {
                case 0:
                  return 372; /* *p truncsihi2 */

                case 1:
                  return 374; /* *p truncdihi2 */

                default:
                  return -1;
                }

            case E_SImode:
              if (!nvptx_nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !nvptx_register_operand (operands[1], E_DImode))
                return -1;
              return 375; /* *p truncdisi2 */

            default:
              return -1;
            }

        case LSHIFTRT:
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != MULT)
            return -1;
          x10 = XEXP (x8, 1);
          if (GET_CODE (x10) != CONST_INT)
            return -1;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          x6 = XEXP (x5, 0);
          operands[4] = x6;
          x7 = XEXP (x5, 1);
          operands[5] = x7;
          x11 = XEXP (x9, 0);
          switch (GET_CODE (x11))
            {
            case SIGN_EXTEND:
              switch (pattern60 (x3, SIGN_EXTEND))
                {
                case 0:
                  return 442; /* *p smulhi3_highpart */

                case 1:
                  return 443; /* *p smulsi3_highpart */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern60 (x3, ZERO_EXTEND))
                {
                case 0:
                  return 444; /* *p umulhi3_highpart */

                case 1:
                  return 445; /* *p umulsi3_highpart */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case REG:
          operands[1] = x8;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          x6 = XEXP (x5, 0);
          operands[4] = x6;
          x7 = XEXP (x5, 1);
          operands[5] = x7;
          switch (pattern26 (x3))
            {
            case 0:
              return 382; /* *p addhi3 */

            case 1:
              return 383; /* *p addsi3 */

            case 2:
              return 384; /* *p adddi3 */

            case 3:
              return 501; /* *p addsf3 */

            case 4:
              return 502; /* *p adddf3 */

            case 5:
              if (!
#line 1142 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
                return -1;
              return 529; /* *p addhf3 */

            default:
              return -1;
            }

        case PLUS:
          if (pattern46 (x1) != 0)
            return -1;
          return 385; /* *p *vadd_addsi4 */

        case MINUS:
          if (pattern46 (x1) != 0)
            return -1;
          return 386; /* *p *vsub_addsi4 */

        case MULT:
          x5 = XEXP (x1, 0);
          operands[4] = x5;
          x6 = XEXP (x5, 0);
          operands[5] = x6;
          x7 = XEXP (x5, 1);
          operands[6] = x7;
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          x10 = XEXP (x8, 1);
          operands[2] = x10;
          x12 = XEXP (x3, 1);
          operands[3] = x12;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern64 (x3, E_HImode) != 0)
                return -1;
              return 393; /* *p *madhi3 */

            case E_SImode:
              if (pattern64 (x3, E_SImode) != 0)
                return -1;
              return 394; /* *p *madsi3 */

            case E_DImode:
              if (pattern64 (x3, E_DImode) != 0)
                return -1;
              return 395; /* *p *maddi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      x12 = XEXP (x3, 1);
      operands[2] = x12;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern25 (x3, E_HImode) != 0)
            return -1;
          return 387; /* *p subhi3 */

        case E_SImode:
          if (pattern25 (x3, E_SImode) != 0)
            return -1;
          return 388; /* *p subsi3 */

        case E_DImode:
          if (pattern25 (x3, E_DImode) != 0)
            return -1;
          return 389; /* *p subdi3 */

        case E_SFmode:
          if (pattern25 (x3, E_SFmode) != 0)
            return -1;
          return 503; /* *p subsf3 */

        case E_DFmode:
          if (pattern25 (x3, E_DFmode) != 0)
            return -1;
          return 504; /* *p subdf3 */

        case E_HFmode:
          if (pattern25 (x3, E_HFmode) != 0
              || !
#line 1149 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
            return -1;
          return 530; /* *p subhf3 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case REG:
          operands[1] = x8;
          switch (pattern26 (x3))
            {
            case 0:
              return 390; /* *p mulhi3 */

            case 1:
              return 391; /* *p mulsi3 */

            case 2:
              return 392; /* *p muldi3 */

            case 3:
              return 505; /* *p mulsf3 */

            case 4:
              return 506; /* *p muldf3 */

            case 5:
              if (!
#line 1156 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
                return -1;
              return 531; /* *p mulhf3 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern53 (x3, SIGN_EXTEND))
            {
            case 0:
              return 438; /* *p mulhisi3 */

            case 1:
              return 439; /* *p mulsidi3 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern53 (x3, ZERO_EXTEND))
            {
            case 0:
              return 440; /* *p umulhisi3 */

            case 1:
              return 441; /* *p umulsidi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case DIV:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case REG:
          operands[1] = x8;
          x12 = XEXP (x3, 1);
          operands[2] = x12;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern23 (x3, E_HImode) != 0)
                return -1;
              return 396; /* *p divhi3 */

            case E_SImode:
              if (pattern23 (x3, E_SImode) != 0)
                return -1;
              return 397; /* *p divsi3 */

            case E_DImode:
              if (pattern23 (x3, E_DImode) != 0)
                return -1;
              return 398; /* *p divdi3 */

            case E_SFmode:
              if (pattern23 (x3, E_SFmode) != 0)
                return -1;
              return 511; /* *p divsf3 */

            case E_DFmode:
              if (pattern23 (x3, E_DFmode) != 0)
                return -1;
              return 512; /* *p divdf3 */

            default:
              return -1;
            }

        case CONST_DOUBLE:
          operands[2] = x8;
          x12 = XEXP (x3, 1);
          operands[1] = x12;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern61 (x3, E_SFmode) != 0
                  || !
#line 1046 "../../gcc/config/nvptx/nvptx.md"
(CONST_DOUBLE_P (operands[2])
   && real_identical (CONST_DOUBLE_REAL_VALUE (operands[2]), &dconst1)))
                return -1;
              return 509; /* *p *recipsf2 */

            case E_DFmode:
              if (pattern61 (x3, E_DFmode) != 0
                  || !
#line 1046 "../../gcc/config/nvptx/nvptx.md"
(CONST_DOUBLE_P (operands[2])
   && real_identical (CONST_DOUBLE_REAL_VALUE (operands[2]), &dconst1)))
                return -1;
              return 510; /* *p *recipdf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UDIV:
      switch (pattern24 (x1))
        {
        case 0:
          return 399; /* *p udivhi3 */

        case 1:
          return 400; /* *p udivsi3 */

        case 2:
          return 401; /* *p udivdi3 */

        default:
          return -1;
        }

    case MOD:
      switch (pattern24 (x1))
        {
        case 0:
          return 402; /* *p modhi3 */

        case 1:
          return 403; /* *p modsi3 */

        case 2:
          return 404; /* *p moddi3 */

        default:
          return -1;
        }

    case UMOD:
      switch (pattern24 (x1))
        {
        case 0:
          return 405; /* *p umodhi3 */

        case 1:
          return 406; /* *p umodsi3 */

        case 2:
          return 407; /* *p umoddi3 */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern27 (x1))
        {
        case 0:
          return 408; /* *p sminhi3 */

        case 1:
          return 409; /* *p sminsi3 */

        case 2:
          return 410; /* *p smindi3 */

        case 3:
          return 515; /* *p sminsf3 */

        case 4:
          return 516; /* *p smindf3 */

        case 5:
          if (!
#line 1179 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM80))
            return -1;
          return 535; /* *p sminhf3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern24 (x1))
        {
        case 0:
          return 411; /* *p uminhi3 */

        case 1:
          return 412; /* *p uminsi3 */

        case 2:
          return 413; /* *p umindi3 */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern27 (x1))
        {
        case 0:
          return 414; /* *p smaxhi3 */

        case 1:
          return 415; /* *p smaxsi3 */

        case 2:
          return 416; /* *p smaxdi3 */

        case 3:
          return 517; /* *p smaxsf3 */

        case 4:
          return 518; /* *p smaxdf3 */

        case 5:
          if (!
#line 1186 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM80))
            return -1;
          return 536; /* *p smaxhf3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern24 (x1))
        {
        case 0:
          return 417; /* *p umaxhi3 */

        case 1:
          return 418; /* *p umaxsi3 */

        case 2:
          return 419; /* *p umaxdi3 */

        default:
          return -1;
        }

    case ABS:
      switch (pattern28 (x1))
        {
        case 0:
          return 420; /* *p abshi2 */

        case 1:
          return 421; /* *p abssi2 */

        case 2:
          return 422; /* *p absdi2 */

        case 3:
          return 519; /* *p abssf2 */

        case 4:
          return 520; /* *p absdf2 */

        default:
          return -1;
        }

    case NEG:
      switch (pattern28 (x1))
        {
        case 0:
          return 423; /* *p neghi2 */

        case 1:
          return 424; /* *p negsi2 */

        case 2:
          return 425; /* *p negdi2 */

        case 3:
          return 521; /* *p negsf2 */

        case 4:
          return 522; /* *p negdf2 */

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      switch (pattern30 (x3))
        {
        case 0:
          return 426; /* *p one_cmplhi2 */

        case 1:
          return 427; /* *p one_cmplsi2 */

        case 2:
          return 428; /* *p one_cmpldi2 */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          res = recog_8 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          operands[1] = x3;
          x5 = XEXP (x1, 0);
          operands[4] = x5;
          x6 = XEXP (x5, 0);
          operands[5] = x6;
          x7 = XEXP (x5, 1);
          operands[6] = x7;
          x8 = XEXP (x3, 0);
          operands[2] = x8;
          x12 = XEXP (x3, 1);
          operands[3] = x12;
          switch (GET_MODE (operands[0]))
            {
            case E_BImode:
              switch (pattern66 (E_BImode))
                {
                case 0:
                  return 467; /* *p *cmphi */

                case 1:
                  return 468; /* *p *cmpsi */

                case 2:
                  return 469; /* *p *cmpdi */

                default:
                  return -1;
                }

            case E_SFmode:
              switch (pattern66 (E_SFmode))
                {
                case 0:
                  return 492; /* *p setcc_floathi */

                case 1:
                  return 493; /* *p setcc_floatsi */

                case 2:
                  return 494; /* *p setcc_floatdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CLZ:
      switch (pattern29 (x1))
        {
        case 0:
          return 434; /* *p clzsi2 */

        case 1:
          return 435; /* *p clzdi2 */

        default:
          return -1;
        }

    case POPCOUNT:
      switch (pattern29 (x1))
        {
        case 0:
          return 436; /* *p popcountsi2 */

        case 1:
          return 437; /* *p popcountdi2 */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern31 (x1))
        {
        case 0:
          return 446; /* *p ashlhi3 */

        case 1:
          return 447; /* *p ashlsi3 */

        case 2:
          return 448; /* *p ashldi3 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern31 (x1))
        {
        case 0:
          return 449; /* *p ashrhi3 */

        case 1:
          return 450; /* *p ashrsi3 */

        case 2:
          return 451; /* *p ashrdi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern31 (x1))
        {
        case 0:
          return 452; /* *p lshrhi3 */

        case 1:
          return 453; /* *p lshrsi3 */

        case 2:
          return 454; /* *p lshrdi3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern32 (x1))
        {
        case 0:
          return 455; /* *p andbi3 */

        case 1:
          return 456; /* *p andhi3 */

        case 2:
          return 457; /* *p andsi3 */

        case 3:
          return 458; /* *p anddi3 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern32 (x1))
        {
        case 0:
          return 459; /* *p iorbi3 */

        case 1:
          return 460; /* *p iorhi3 */

        case 2:
          return 461; /* *p iorsi3 */

        case 3:
          return 462; /* *p iordi3 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern32 (x1))
        {
        case 0:
          return 463; /* *p xorbi3 */

        case 1:
          return 464; /* *p xorhi3 */

        case 2:
          return 465; /* *p xorsi3 */

        case 3:
          return 466; /* *p xordi3 */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      x5 = XEXP (x1, 0);
      operands[4] = x5;
      x6 = XEXP (x5, 0);
      operands[5] = x6;
      x7 = XEXP (x5, 1);
      operands[6] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x12 = XEXP (x3, 1);
      operands[2] = x12;
      x13 = XEXP (x3, 2);
      operands[3] = x13;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case NE:
          switch (pattern57 (x3))
            {
            case 0:
              return 482; /* *p sel_truehi */

            case 1:
              return 483; /* *p sel_truesi */

            case 2:
              return 484; /* *p sel_truedi */

            case 3:
              return 485; /* *p sel_truesf */

            case 4:
              return 486; /* *p sel_truedf */

            default:
              return -1;
            }

        case EQ:
          switch (pattern57 (x3))
            {
            case 0:
              return 487; /* *p sel_falsehi */

            case 1:
              return 488; /* *p sel_falsesi */

            case 2:
              return 489; /* *p sel_falsedi */

            case 3:
              return 490; /* *p sel_falsesf */

            case 4:
              return 491; /* *p sel_falsedf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FMA:
      x5 = XEXP (x1, 0);
      operands[4] = x5;
      x6 = XEXP (x5, 0);
      operands[5] = x6;
      x7 = XEXP (x5, 1);
      operands[6] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      x12 = XEXP (x3, 1);
      operands[2] = x12;
      x13 = XEXP (x3, 2);
      operands[3] = x13;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern62 (x3, E_SFmode) != 0)
            return -1;
          return 507; /* *p fmasf4 */

        case E_DFmode:
          if (pattern62 (x3, E_DFmode) != 0)
            return -1;
          return 508; /* *p fmadf4 */

        default:
          return -1;
        }

    case SQRT:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!nvptx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !nvptx_register_operand (operands[1], E_SFmode))
            return -1;
          return 523; /* *p sqrtsf2 */

        case E_DFmode:
          if (!nvptx_register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !nvptx_register_operand (operands[1], E_DFmode))
            return -1;
          return 524; /* *p sqrtdf2 */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!nvptx_register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!nvptx_register_operand (operands[1], E_SFmode))
                return -1;
              return 537; /* *p extendsfdf2 */

            case E_HFmode:
              if (!nvptx_register_operand (operands[1], E_HFmode)
                  || !
#line 1285 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
                return -1;
              return 572; /* *p extendhfdf2 */

            default:
              return -1;
            }

        case E_SFmode:
          if (!nvptx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !nvptx_register_operand (operands[1], E_HFmode)
              || !
#line 1285 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
            return -1;
          return 571; /* *p extendhfsf2 */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!nvptx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !nvptx_register_operand (operands[1], E_DFmode))
            return -1;
          return 538; /* *p truncdfsf2 */

        case E_HFmode:
          switch (pattern35 (x3, E_HFmode))
            {
            case 0:
              if (!
#line 1291 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
                return -1;
              return 573; /* *p truncsfhf2 */

            case 1:
              if (!
#line 1291 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
                return -1;
              return 574; /* *p truncdfhf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern34 (x1))
        {
        case 0:
          return 539; /* *p floatunssisf2 */

        case 1:
          return 543; /* *p floatunsdisf2 */

        case 2:
          return 540; /* *p floatunssidf2 */

        case 3:
          return 544; /* *p floatunsdidf2 */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern34 (x1))
        {
        case 0:
          return 541; /* *p floatsisf2 */

        case 1:
          return 545; /* *p floatdisf2 */

        case 2:
          return 542; /* *p floatsidf2 */

        case 3:
          return 546; /* *p floatdidf2 */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern36 (x1))
        {
        case 0:
          return 547; /* *p fixuns_truncsfsi2 */

        case 1:
          return 548; /* *p fixuns_truncdfsi2 */

        case 2:
          return 551; /* *p fixuns_truncsfdi2 */

        case 3:
          return 552; /* *p fixuns_truncdfdi2 */

        default:
          return -1;
        }

    case FIX:
      switch (pattern36 (x1))
        {
        case 0:
          return 549; /* *p fix_truncsfsi2 */

        case 1:
          return 550; /* *p fix_truncdfsi2 */

        case 2:
          return 553; /* *p fix_truncsfdi2 */

        case 3:
          return 554; /* *p fix_truncdfdi2 */

        default:
          return -1;
        }

    case VEC_MERGE:
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != VEC_DUPLICATE)
        return -1;
      x13 = XEXP (x3, 2);
      if (GET_CODE (x13) != CONST_INT)
        return -1;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      x12 = XEXP (x3, 1);
      if (!rtx_equal_p (x12, operands[0]))
        return -1;
      switch (XWINT (x13, 0))
        {
        case 1L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern68 (x3, E_SImode, E_V2SImode) != 0)
                return -1;
              return 575; /* *p *vec_setv2si_0 */

            case E_V2DImode:
              if (pattern68 (x3, E_DImode, E_V2DImode) != 0)
                return -1;
              return 576; /* *p *vec_setv2di_0 */

            default:
              return -1;
            }

        case 2L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern68 (x3, E_SImode, E_V2SImode) != 0)
                return -1;
              return 577; /* *p *vec_setv2si_1 */

            case E_V2DImode:
              if (pattern68 (x3, E_DImode, E_V2DImode) != 0)
                return -1;
              return 578; /* *p *vec_setv2di_1 */

            default:
              return -1;
            }

        case 4L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern68 (x3, E_SImode, E_V2SImode) != 0)
                return -1;
              return 579; /* *p *vec_setv2si_2 */

            case E_V2DImode:
              if (pattern68 (x3, E_DImode, E_V2DImode) != 0)
                return -1;
              return 580; /* *p *vec_setv2di_2 */

            default:
              return -1;
            }

        case 8L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern68 (x3, E_SImode, E_V2SImode) != 0)
                return -1;
              return 581; /* *p *vec_setv2si_3 */

            case E_V2DImode:
              if (pattern68 (x3, E_DImode, E_V2DImode) != 0)
                return -1;
              return 582; /* *p *vec_setv2di_3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x12 = XEXP (x3, 1);
      if (GET_CODE (x12) != PARALLEL
          || XVECLEN (x12, 0) != 1)
        return -1;
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      x14 = XVECEXP (x12, 0, 0);
      operands[2] = x14;
      if (!nvptx_vector_index_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !nvptx_register_operand (operands[1], E_V2SImode))
            return -1;
          return 583; /* *p vec_extractv2sisi */

        case E_DImode:
          if (!nvptx_register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !nvptx_register_operand (operands[1], E_V2DImode))
            return -1;
          return 584; /* *p vec_extractv2didi */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (XVECLEN (x3, 0))
        {
        case 1:
          if (XINT (x3, 1) != 6
              || GET_MODE (x3) != E_SImode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          if (!nvptx_register_operand (operands[0], E_SImode))
            return -1;
          x15 = XVECEXP (x3, 0, 0);
          operands[1] = x15;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          return 592; /* *p oacc_dim_pos */

        case 2:
          if (XINT (x3, 1) != 12)
            return -1;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          x6 = XEXP (x5, 0);
          operands[4] = x6;
          x7 = XEXP (x5, 1);
          operands[5] = x7;
          x15 = XVECEXP (x3, 0, 0);
          operands[1] = x15;
          x16 = XVECEXP (x3, 0, 1);
          operands[2] = x16;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern67 (x3, E_SImode) != 0
                  || !
#line 208 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
                return -1;
              return 596; /* *p omp_simt_enter_si */

            case E_DImode:
              if (pattern67 (x3, E_DImode) != 0
                  || !
#line 208 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
                return -1;
              return 597; /* *p omp_simt_enter_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_4 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_3 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern11 (x2))
        {
        case 0:
          if (!nvptx_nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 17; /* zero_extendqihi2 */

        case 1:
          if (!nvptx_register_operand (operands[1], E_BImode))
            return -1;
          return 142; /* zero_extendbihi2 */

        case 2:
          return 18; /* zero_extendqisi2 */

        case 3:
          return 19; /* zero_extendhisi2 */

        case 4:
          return 143; /* zero_extendbisi2 */

        case 5:
          return 20; /* zero_extendqidi2 */

        case 6:
          return 21; /* zero_extendhidi2 */

        case 7:
          return 22; /* zero_extendsidi2 */

        case 8:
          return 144; /* zero_extendbidi2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case MEM:
          switch (pattern11 (x2))
            {
            case 0:
              if (!nvptx_register_operand (operands[1], E_QImode))
                return -1;
              return 23; /* extendqihi2 */

            case 1:
              if (!nvptx_register_operand (operands[1], E_BImode))
                return -1;
              return 139; /* extendbihi2 */

            case 2:
              return 24; /* extendqisi2 */

            case 3:
              return 25; /* extendhisi2 */

            case 4:
              return 140; /* extendbisi2 */

            case 5:
              return 26; /* extendqidi2 */

            case 6:
              return 27; /* extendhidi2 */

            case 7:
              return 28; /* extendsidi2 */

            case 8:
              return 141; /* extendbidi2 */

            default:
              return -1;
            }

        case TRUNCATE:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!nvptx_register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || GET_MODE (x4) != E_QImode
                  || !nvptx_register_operand (operands[1], E_HImode))
                return -1;
              return 35; /* *extend_trunc_hi2_qi */

            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !nvptx_register_operand (operands[1], E_SImode))
                return -1;
              switch (GET_MODE (x4))
                {
                case E_QImode:
                  return 36; /* *extend_trunc_si2_qi */

                case E_HImode:
                  return 38; /* *extend_trunc_si2_hi */

                default:
                  return -1;
                }

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !nvptx_register_operand (operands[1], E_DImode))
                return -1;
              switch (GET_MODE (x4))
                {
                case E_QImode:
                  return 37; /* *extend_trunc_di2_qi */

                case E_HImode:
                  return 39; /* *extend_trunc_di2_hi */

                case E_SImode:
                  return 40; /* *extend_trunc_di2_si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!nvptx_nonimmediate_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_HImode:
                  if (!nvptx_register_operand (operands[1], E_HImode))
                    return -1;
                  return 29; /* trunchiqi2 */

                case E_SImode:
                  if (!nvptx_register_operand (operands[1], E_SImode))
                    return -1;
                  return 30; /* truncsiqi2 */

                case E_DImode:
                  if (!nvptx_register_operand (operands[1], E_DImode))
                    return -1;
                  return 32; /* truncdiqi2 */

                default:
                  return -1;
                }

            case E_HImode:
              if (!nvptx_nonimmediate_operand (operands[0], E_HImode))
                return -1;
              switch (pattern7 (x2, E_HImode))
                {
                case 0:
                  return 31; /* truncsihi2 */

                case 1:
                  return 33; /* truncdihi2 */

                default:
                  return -1;
                }

            case E_SImode:
              if (!nvptx_nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !nvptx_register_operand (operands[1], E_DImode))
                return -1;
              return 34; /* truncdisi2 */

            default:
              return -1;
            }

        case LSHIFTRT:
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != MULT)
            return -1;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != CONST_INT)
            return -1;
          x7 = XEXP (x5, 0);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              switch (pattern38 (x2, SIGN_EXTEND))
                {
                case 0:
                  return 101; /* smulhi3_highpart */

                case 1:
                  return 102; /* smulsi3_highpart */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern38 (x2, ZERO_EXTEND))
                {
                case 0:
                  return 103; /* umulhi3_highpart */

                case 1:
                  return 104; /* umulsi3_highpart */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
          switch (pattern13 (x2))
            {
            case 0:
              return 41; /* addhi3 */

            case 1:
              return 42; /* addsi3 */

            case 2:
              return 43; /* adddi3 */

            case 3:
              return 164; /* addsf3 */

            case 4:
              return 165; /* adddf3 */

            case 5:
              if (!
#line 1142 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
                return -1;
              return 192; /* addhf3 */

            default:
              return -1;
            }

        case PLUS:
          if (pattern16 (x2) != 0)
            return -1;
          return 44; /* *vadd_addsi4 */

        case MINUS:
          if (pattern16 (x2) != 0)
            return -1;
          return 45; /* *vsub_addsi4 */

        case MULT:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          x8 = XEXP (x2, 1);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern42 (x2, E_HImode) != 0)
                return -1;
              return 52; /* *madhi3 */

            case E_SImode:
              if (pattern42 (x2, E_SImode) != 0)
                return -1;
              return 53; /* *madsi3 */

            case E_DImode:
              if (pattern42 (x2, E_DImode) != 0)
                return -1;
              return 54; /* *maddi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern12 (x2, E_HImode) != 0)
            return -1;
          return 46; /* subhi3 */

        case E_SImode:
          if (pattern12 (x2, E_SImode) != 0)
            return -1;
          return 47; /* subsi3 */

        case E_DImode:
          if (pattern12 (x2, E_DImode) != 0)
            return -1;
          return 48; /* subdi3 */

        case E_SFmode:
          if (pattern12 (x2, E_SFmode) != 0)
            return -1;
          return 166; /* subsf3 */

        case E_DFmode:
          if (pattern12 (x2, E_DFmode) != 0)
            return -1;
          return 167; /* subdf3 */

        case E_HFmode:
          if (pattern12 (x2, E_HFmode) != 0
              || !
#line 1149 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
            return -1;
          return 193; /* subhf3 */

        default:
          return -1;
        }

    case MULT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
          switch (pattern13 (x2))
            {
            case 0:
              return 49; /* mulhi3 */

            case 1:
              return 50; /* mulsi3 */

            case 2:
              return 51; /* muldi3 */

            case 3:
              return 168; /* mulsf3 */

            case 4:
              return 169; /* muldf3 */

            case 5:
              if (!
#line 1156 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
                return -1;
              return 194; /* mulhf3 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern18 (x2, SIGN_EXTEND))
            {
            case 0:
              return 97; /* mulhisi3 */

            case 1:
              return 98; /* mulsidi3 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern18 (x2, ZERO_EXTEND))
            {
            case 0:
              return 99; /* umulhisi3 */

            case 1:
              return 100; /* umulsidi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
          operands[1] = x4;
          x8 = XEXP (x2, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern0 (x2, E_HImode) != 0)
                return -1;
              return 55; /* divhi3 */

            case E_SImode:
              if (pattern0 (x2, E_SImode) != 0)
                return -1;
              return 56; /* divsi3 */

            case E_DImode:
              if (pattern0 (x2, E_DImode) != 0)
                return -1;
              return 57; /* divdi3 */

            case E_SFmode:
              if (pattern0 (x2, E_SFmode) != 0)
                return -1;
              return 174; /* divsf3 */

            case E_DFmode:
              if (pattern0 (x2, E_DFmode) != 0)
                return -1;
              return 175; /* divdf3 */

            default:
              return -1;
            }

        case CONST_DOUBLE:
          operands[2] = x4;
          x8 = XEXP (x2, 1);
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern39 (x2, E_SFmode) != 0
                  || !
#line 1046 "../../gcc/config/nvptx/nvptx.md"
(CONST_DOUBLE_P (operands[2])
   && real_identical (CONST_DOUBLE_REAL_VALUE (operands[2]), &dconst1)))
                return -1;
              return 172; /* *recipsf2 */

            case E_DFmode:
              if (pattern39 (x2, E_DFmode) != 0
                  || !
#line 1046 "../../gcc/config/nvptx/nvptx.md"
(CONST_DOUBLE_P (operands[2])
   && real_identical (CONST_DOUBLE_REAL_VALUE (operands[2]), &dconst1)))
                return -1;
              return 173; /* *recipdf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UDIV:
      switch (pattern1 (x1))
        {
        case 0:
          return 58; /* udivhi3 */

        case 1:
          return 59; /* udivsi3 */

        case 2:
          return 60; /* udivdi3 */

        default:
          return -1;
        }

    case MOD:
      switch (pattern1 (x1))
        {
        case 0:
          return 61; /* modhi3 */

        case 1:
          return 62; /* modsi3 */

        case 2:
          return 63; /* moddi3 */

        default:
          return -1;
        }

    case UMOD:
      switch (pattern1 (x1))
        {
        case 0:
          return 64; /* umodhi3 */

        case 1:
          return 65; /* umodsi3 */

        case 2:
          return 66; /* umoddi3 */

        default:
          return -1;
        }

    case SMIN:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern13 (x2))
        {
        case 0:
          return 67; /* sminhi3 */

        case 1:
          return 68; /* sminsi3 */

        case 2:
          return 69; /* smindi3 */

        case 3:
          return 178; /* sminsf3 */

        case 4:
          return 179; /* smindf3 */

        case 5:
          if (!
#line 1179 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM80))
            return -1;
          return 198; /* sminhf3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern1 (x1))
        {
        case 0:
          return 70; /* uminhi3 */

        case 1:
          return 71; /* uminsi3 */

        case 2:
          return 72; /* umindi3 */

        default:
          return -1;
        }

    case SMAX:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern13 (x2))
        {
        case 0:
          return 73; /* smaxhi3 */

        case 1:
          return 74; /* smaxsi3 */

        case 2:
          return 75; /* smaxdi3 */

        case 3:
          return 180; /* smaxsf3 */

        case 4:
          return 181; /* smaxdf3 */

        case 5:
          if (!
#line 1186 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM80))
            return -1;
          return 199; /* smaxhf3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern1 (x1))
        {
        case 0:
          return 76; /* umaxhi3 */

        case 1:
          return 77; /* umaxsi3 */

        case 2:
          return 78; /* umaxdi3 */

        default:
          return -1;
        }

    case ABS:
      switch (pattern2 (x1))
        {
        case 0:
          return 79; /* abshi2 */

        case 1:
          return 80; /* abssi2 */

        case 2:
          return 81; /* absdi2 */

        case 3:
          return 182; /* abssf2 */

        case 4:
          return 183; /* absdf2 */

        default:
          return -1;
        }

    case NEG:
      switch (pattern2 (x1))
        {
        case 0:
          return 82; /* neghi2 */

        case 1:
          return 83; /* negsi2 */

        case 2:
          return 84; /* negdi2 */

        case 3:
          return 184; /* negsf2 */

        case 4:
          return 185; /* negdf2 */

        default:
          return -1;
        }

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern4 (x2))
        {
        case 0:
          return 85; /* one_cmplhi2 */

        case 1:
          return 86; /* one_cmplsi2 */

        case 2:
          return 87; /* one_cmpldi2 */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_CODE (x2))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          res = recog_2 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      switch (GET_CODE (x2))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          operands[1] = x2;
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          x8 = XEXP (x2, 1);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_BImode:
              switch (pattern44 (E_BImode))
                {
                case 0:
                  return 126; /* *cmphi */

                case 1:
                  return 127; /* *cmpsi */

                case 2:
                  return 128; /* *cmpdi */

                default:
                  return -1;
                }

            case E_SFmode:
              switch (pattern44 (E_SFmode))
                {
                case 0:
                  return 155; /* setcc_floathi */

                case 1:
                  return 156; /* setcc_floatsi */

                case 2:
                  return 157; /* setcc_floatdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CLZ:
      switch (pattern3 (x1))
        {
        case 0:
          return 93; /* clzsi2 */

        case 1:
          return 94; /* clzdi2 */

        default:
          return -1;
        }

    case POPCOUNT:
      switch (pattern3 (x1))
        {
        case 0:
          return 95; /* popcountsi2 */

        case 1:
          return 96; /* popcountdi2 */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern5 (x1))
        {
        case 0:
          return 105; /* ashlhi3 */

        case 1:
          return 106; /* ashlsi3 */

        case 2:
          return 107; /* ashldi3 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern5 (x1))
        {
        case 0:
          return 108; /* ashrhi3 */

        case 1:
          return 109; /* ashrsi3 */

        case 2:
          return 110; /* ashrdi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern5 (x1))
        {
        case 0:
          return 111; /* lshrhi3 */

        case 1:
          return 112; /* lshrsi3 */

        case 2:
          return 113; /* lshrdi3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern6 (x1))
        {
        case 0:
          return 114; /* andbi3 */

        case 1:
          return 115; /* andhi3 */

        case 2:
          return 116; /* andsi3 */

        case 3:
          return 117; /* anddi3 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern6 (x1))
        {
        case 0:
          return 118; /* iorbi3 */

        case 1:
          return 119; /* iorhi3 */

        case 2:
          return 120; /* iorsi3 */

        case 3:
          return 121; /* iordi3 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern6 (x1))
        {
        case 0:
          return 122; /* xorbi3 */

        case 1:
          return 123; /* xorhi3 */

        case 2:
          return 124; /* xorsi3 */

        case 3:
          return 125; /* xordi3 */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case NE:
          switch (pattern15 (x1))
            {
            case 0:
              return 132; /* br_true */

            case 1:
              return 145; /* sel_truehi */

            case 2:
              return 146; /* sel_truesi */

            case 3:
              return 147; /* sel_truedi */

            case 4:
              return 148; /* sel_truesf */

            case 5:
              return 149; /* sel_truedf */

            case 6:
              return 134; /* br_true_uni */

            default:
              return -1;
            }

        case EQ:
          switch (pattern15 (x1))
            {
            case 0:
              return 133; /* br_false */

            case 1:
              return 150; /* sel_falsehi */

            case 2:
              return 151; /* sel_falsesi */

            case 3:
              return 152; /* sel_falsedi */

            case 4:
              return 153; /* sel_falsesf */

            case 5:
              return 154; /* sel_falsedf */

            case 6:
              return 135; /* br_false_uni */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FMA:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      x9 = XEXP (x2, 2);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern40 (x2, E_SFmode) != 0)
            return -1;
          return 170; /* fmasf4 */

        case E_DFmode:
          if (pattern40 (x2, E_DFmode) != 0)
            return -1;
          return 171; /* fmadf4 */

        default:
          return -1;
        }

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!nvptx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !nvptx_register_operand (operands[1], E_SFmode))
            return -1;
          return 186; /* sqrtsf2 */

        case E_DFmode:
          if (!nvptx_register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !nvptx_register_operand (operands[1], E_DFmode))
            return -1;
          return 187; /* sqrtdf2 */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!nvptx_register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!nvptx_register_operand (operands[1], E_SFmode))
                return -1;
              return 200; /* extendsfdf2 */

            case E_HFmode:
              if (!nvptx_register_operand (operands[1], E_HFmode)
                  || !
#line 1285 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
                return -1;
              return 235; /* extendhfdf2 */

            default:
              return -1;
            }

        case E_SFmode:
          if (!nvptx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !nvptx_register_operand (operands[1], E_HFmode)
              || !
#line 1285 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
            return -1;
          return 234; /* extendhfsf2 */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!nvptx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !nvptx_register_operand (operands[1], E_DFmode))
            return -1;
          return 201; /* truncdfsf2 */

        case E_HFmode:
          switch (pattern9 (x2, E_HFmode))
            {
            case 0:
              if (!
#line 1291 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
                return -1;
              return 236; /* truncsfhf2 */

            case 1:
              if (!
#line 1291 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
                return -1;
              return 237; /* truncdfhf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern8 (x1))
        {
        case 0:
          return 202; /* floatunssisf2 */

        case 1:
          return 206; /* floatunsdisf2 */

        case 2:
          return 203; /* floatunssidf2 */

        case 3:
          return 207; /* floatunsdidf2 */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern8 (x1))
        {
        case 0:
          return 204; /* floatsisf2 */

        case 1:
          return 208; /* floatdisf2 */

        case 2:
          return 205; /* floatsidf2 */

        case 3:
          return 209; /* floatdidf2 */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern10 (x1))
        {
        case 0:
          return 210; /* fixuns_truncsfsi2 */

        case 1:
          return 211; /* fixuns_truncdfsi2 */

        case 2:
          return 214; /* fixuns_truncsfdi2 */

        case 3:
          return 215; /* fixuns_truncdfdi2 */

        default:
          return -1;
        }

    case FIX:
      switch (pattern10 (x1))
        {
        case 0:
          return 212; /* fix_truncsfsi2 */

        case 1:
          return 213; /* fix_truncdfsi2 */

        case 2:
          return 216; /* fix_truncsfdi2 */

        case 3:
          return 217; /* fix_truncdfdi2 */

        default:
          return -1;
        }

    case VEC_MERGE:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != VEC_DUPLICATE)
        return -1;
      x9 = XEXP (x2, 2);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x8 = XEXP (x2, 1);
      if (!rtx_equal_p (x8, operands[0]))
        return -1;
      switch (XWINT (x9, 0))
        {
        case 1L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern47 (x2, E_SImode, E_V2SImode) != 0)
                return -1;
              return 238; /* *vec_setv2si_0 */

            case E_V2DImode:
              if (pattern47 (x2, E_DImode, E_V2DImode) != 0)
                return -1;
              return 239; /* *vec_setv2di_0 */

            default:
              return -1;
            }

        case 2L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern47 (x2, E_SImode, E_V2SImode) != 0)
                return -1;
              return 240; /* *vec_setv2si_1 */

            case E_V2DImode:
              if (pattern47 (x2, E_DImode, E_V2DImode) != 0)
                return -1;
              return 241; /* *vec_setv2di_1 */

            default:
              return -1;
            }

        case 4L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern47 (x2, E_SImode, E_V2SImode) != 0)
                return -1;
              return 242; /* *vec_setv2si_2 */

            case E_V2DImode:
              if (pattern47 (x2, E_DImode, E_V2DImode) != 0)
                return -1;
              return 243; /* *vec_setv2di_2 */

            default:
              return -1;
            }

        case 8L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern47 (x2, E_SImode, E_V2SImode) != 0)
                return -1;
              return 244; /* *vec_setv2si_3 */

            case E_V2DImode:
              if (pattern47 (x2, E_DImode, E_V2DImode) != 0)
                return -1;
              return 245; /* *vec_setv2di_3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x8 = XEXP (x2, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x10 = XVECEXP (x8, 0, 0);
      operands[2] = x10;
      if (!nvptx_vector_index_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !nvptx_register_operand (operands[1], E_V2SImode))
            return -1;
          return 246; /* vec_extractv2sisi */

        case E_DImode:
          if (!nvptx_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !nvptx_register_operand (operands[1], E_V2DImode))
            return -1;
          return 247; /* vec_extractv2didi */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          switch (XINT (x2, 1))
            {
            case 6:
              if (GET_MODE (x2) != E_SImode
                  || !nvptx_register_operand (operands[0], E_SImode))
                return -1;
              x11 = XVECEXP (x2, 0, 0);
              operands[1] = x11;
              if (!const_int_operand (operands[1], E_SImode))
                return -1;
              return 258; /* oacc_dim_pos */

            case 4:
              if (GET_MODE (x2) != E_BLKmode)
                return -1;
              x11 = XVECEXP (x2, 0, 0);
              if (!rtx_equal_p (x11, operands[0]))
                return -1;
              return 289; /* *memory_barrier */

            case 5:
              if (GET_MODE (x2) != E_BLKmode)
                return -1;
              x11 = XVECEXP (x2, 0, 0);
              if (!rtx_equal_p (x11, operands[0]))
                return -1;
              return 290; /* *nvptx_membar_cta */

            case 14:
              if (GET_MODE (x2) != E_DImode
                  || !nonimmediate_operand (operands[0], E_DImode))
                return -1;
              x11 = XVECEXP (x2, 0, 0);
              operands[1] = x11;
              if (!const_int_operand (operands[1], E_DImode))
                return -1;
              return 292; /* nvptx_red_partition */

            default:
              return -1;
            }

        case 2:
          if (XINT (x2, 1) != 12)
            return -1;
          x11 = XVECEXP (x2, 0, 0);
          operands[1] = x11;
          x12 = XVECEXP (x2, 0, 1);
          operands[2] = x12;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern45 (x2, E_SImode) != 0
                  || !
#line 208 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
                return -1;
              return 266; /* omp_simt_enter_si */

            case E_DImode:
              if (pattern45 (x2, E_DImode) != 0
                  || !
#line 208 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
                return -1;
              return 267; /* omp_simt_enter_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_12 (x1, insn, pnum_clobbers);

    case PARALLEL:
      if (XVECLEN (x1, 0) >= 1
          && call_operation (x1, E_VOIDmode))
        {
          res = recog_5 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (x1, 0) != 2)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != SET)
        return -1;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case UNSPEC:
          if (XVECLEN (x4, 0) != 2
              || XINT (x4, 1) != 15
              || GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XVECEXP (x4, 0, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XEXP (x3, 1);
          if (GET_CODE (x6) != UNSPEC
              || XVECLEN (x6, 0) != 2
              || XINT (x6, 1) != 15
              || GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XVECEXP (x6, 0, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          if (!nvptx_register_operand (operands[0], E_SImode))
            return -1;
          x9 = XVECEXP (x4, 0, 0);
          operands[2] = x9;
          x10 = XEXP (x3, 0);
          operands[1] = x10;
          if (!nvptx_register_operand (operands[1], E_SImode))
            return -1;
          x11 = XVECEXP (x6, 0, 0);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_DImode:
              if (!nvptx_register_operand (operands[2], E_DImode))
                return -1;
              return 271; /* unpackdisi2 */

            case E_DFmode:
              if (!nvptx_register_operand (operands[2], E_DFmode))
                return -1;
              return 272; /* unpackdfsi2 */

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          switch (XVECLEN (x4, 0))
            {
            case 4:
              if (XINT (x4, 1) != 1)
                return -1;
              x6 = XEXP (x3, 1);
              if (GET_CODE (x6) != UNSPEC_VOLATILE
                  || XVECLEN (x6, 0) != 1
                  || XINT (x6, 1) != 1)
                return -1;
              x11 = XVECEXP (x6, 0, 0);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x8 = XEXP (x2, 0);
              operands[0] = x8;
              x9 = XVECEXP (x4, 0, 0);
              operands[1] = x9;
              x5 = XVECEXP (x4, 0, 1);
              operands[2] = x5;
              x12 = XVECEXP (x4, 0, 2);
              operands[3] = x12;
              x13 = XVECEXP (x4, 0, 3);
              operands[4] = x13;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              x10 = XEXP (x3, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern69 (x1, E_SImode) != 0)
                    return -1;
                  return 275; /* atomic_compare_and_swapsi_1 */

                case E_DImode:
                  if (pattern69 (x1, E_DImode) != 0)
                    return -1;
                  return 276; /* atomic_compare_and_swapdi_1 */

                default:
                  return -1;
                }

            case 2:
              x5 = XVECEXP (x4, 0, 1);
              operands[3] = x5;
              if (!const_int_operand (operands[3], E_SImode))
                return -1;
              switch (XINT (x4, 1))
                {
                case 2:
                  x8 = XEXP (x2, 0);
                  operands[0] = x8;
                  x9 = XVECEXP (x4, 0, 0);
                  operands[1] = x9;
                  x6 = XEXP (x3, 1);
                  operands[2] = x6;
                  x10 = XEXP (x3, 0);
                  if (!rtx_equal_p (x10, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern58 (x4, E_SImode) != 0)
                        return -1;
                      return 277; /* atomic_exchangesi */

                    case E_DImode:
                      if (pattern58 (x4, E_DImode) != 0)
                        return -1;
                      return 278; /* atomic_exchangedi */

                    default:
                      return -1;
                    }

                case 0:
                  x8 = XEXP (x2, 0);
                  operands[1] = x8;
                  x10 = XEXP (x3, 0);
                  operands[0] = x10;
                  x6 = XEXP (x3, 1);
                  if (!rtx_equal_p (x6, operands[1]))
                    return -1;
                  x9 = XVECEXP (x4, 0, 0);
                  switch (GET_CODE (x9))
                    {
                    case PLUS:
                      x14 = XEXP (x9, 1);
                      operands[2] = x14;
                      x15 = XEXP (x9, 0);
                      if (!rtx_equal_p (x15, operands[1]))
                        return -1;
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SImode:
                          if (pattern54 (x4, E_SImode) != 0)
                            return -1;
                          return 279; /* atomic_fetch_addsi */

                        case E_DImode:
                          if (pattern54 (x4, E_DImode) != 0)
                            return -1;
                          return 280; /* atomic_fetch_adddi */

                        case E_SFmode:
                          if (pattern54 (x4, E_SFmode) != 0)
                            return -1;
                          return 281; /* atomic_fetch_addsf */

                        default:
                          return -1;
                        }

                    case AND:
                      switch (pattern55 (x4))
                        {
                        case 0:
                          return 282; /* atomic_fetch_andsi */

                        case 1:
                          if (!
#line 1860 "../../gcc/config/nvptx/nvptx.md"
(DImode == SImode || TARGET_SM35))
                            return -1;
                          return 285; /* atomic_fetch_anddi */

                        default:
                          return -1;
                        }

                    case IOR:
                      switch (pattern55 (x4))
                        {
                        case 0:
                          return 283; /* atomic_fetch_orsi */

                        case 1:
                          if (!
#line 1860 "../../gcc/config/nvptx/nvptx.md"
(DImode == SImode || TARGET_SM35))
                            return -1;
                          return 286; /* atomic_fetch_ordi */

                        default:
                          return -1;
                        }

                    case XOR:
                      switch (pattern55 (x4))
                        {
                        case 0:
                          return 284; /* atomic_fetch_xorsi */

                        case 1:
                          if (!
#line 1860 "../../gcc/config/nvptx/nvptx.md"
(DImode == SImode || TARGET_SM35))
                            return -1;
                          return 287; /* atomic_fetch_xordi */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      switch (XWINT (x1, 0))
        {
        case 0L:
          return 248; /* nop */

        case 1L:
          return 249; /* exit */

        case 2L:
          return 250; /* fake_nop */

        default:
          return -1;
        }

    case RETURN:
      return 251; /* return */

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 13)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[0] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || !(
#line 1449 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SOFT_STACK) && 
#line 208 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode)))
            return -1;
          return 252; /* set_softstack_si */

        case E_DImode:
          if (!nvptx_register_operand (operands[0], E_DImode)
              || !(
#line 1449 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SOFT_STACK) && 
#line 208 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode)))
            return -1;
          return 253; /* set_softstack_di */

        default:
          return -1;
        }

    case TRAP_IF:
      x16 = XEXP (x1, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x17 = XEXP (x1, 0);
      switch (GET_CODE (x17))
        {
        case CONST_INT:
          if (XWINT (x17, 0) != 1L)
            return -1;
          return 254; /* trap */

        case NE:
          x18 = XEXP (x17, 1);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x19 = XEXP (x17, 0);
          operands[0] = x19;
          if (!nvptx_register_operand (operands[0], E_BImode))
            return -1;
          return 255; /* trap_if_true */

        case EQ:
          x18 = XEXP (x17, 1);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x19 = XEXP (x17, 0);
          operands[0] = x19;
          if (!nvptx_register_operand (operands[0], E_BImode))
            return -1;
          return 256; /* trap_if_false */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 7:
              if (GET_MODE (x1) != E_SImode)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              return 259; /* nvptx_fork */

            case 8:
              if (GET_MODE (x1) != E_SImode)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              return 260; /* nvptx_forked */

            case 9:
              if (GET_MODE (x1) != E_SImode)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              return 261; /* nvptx_joining */

            case 10:
              if (GET_MODE (x1) != E_SImode)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              return 262; /* nvptx_join */

            case 13:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!nvptx_register_operand (operands[0], E_SImode)
                      || !
#line 208 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
                    return -1;
                  return 268; /* omp_simt_exit_si */

                case E_DImode:
                  if (!nvptx_register_operand (operands[0], E_DImode)
                      || !
#line 208 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
                    return -1;
                  return 269; /* omp_simt_exit_di */

                default:
                  return -1;
                }

            case 11:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 291; /* nvptx_nounroll */

            default:
              return -1;
            }

        case 2:
          if (XINT (x1, 1) != 3)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!nvptx_nonmemory_operand (operands[0], E_SImode))
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          operands[1] = x3;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          return 288; /* nvptx_barsync */

        default:
          return -1;
        }

    case COND_EXEC:
      x17 = XEXP (x1, 0);
      if (!predicate_operator (x17, E_VOIDmode))
        return -1;
      x19 = XEXP (x17, 0);
      if (!nvptx_register_operand (x19, E_BImode))
        return -1;
      x18 = XEXP (x17, 1);
      if (!const0_operand (x18, E_BImode))
        return -1;
      x16 = XEXP (x1, 1);
      switch (GET_CODE (x16))
        {
        case SET:
          return recog_11 (x1, insn, pnum_clobbers);

        case PARALLEL:
          if (XVECLEN (x16, 0) >= 1
              && call_operation (x16, E_VOIDmode))
            {
              res = recog_10 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XVECLEN (x16, 0) != 2)
            return -1;
          x20 = XVECEXP (x16, 0, 0);
          if (GET_CODE (x20) != SET)
            return -1;
          x21 = XVECEXP (x16, 0, 1);
          if (GET_CODE (x21) != SET)
            return -1;
          x22 = XEXP (x20, 1);
          switch (GET_CODE (x22))
            {
            case UNSPEC:
              if (XVECLEN (x22, 0) != 2
                  || XINT (x22, 1) != 15
                  || GET_MODE (x22) != E_SImode)
                return -1;
              x23 = XVECEXP (x22, 0, 1);
              if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x24 = XEXP (x21, 1);
              if (GET_CODE (x24) != UNSPEC
                  || XVECLEN (x24, 0) != 2
                  || XINT (x24, 1) != 15
                  || GET_MODE (x24) != E_SImode)
                return -1;
              x25 = XVECEXP (x24, 0, 1);
              if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              operands[3] = x17;
              operands[4] = x19;
              operands[5] = x18;
              x26 = XEXP (x20, 0);
              operands[0] = x26;
              if (!nvptx_register_operand (operands[0], E_SImode))
                return -1;
              x27 = XVECEXP (x22, 0, 0);
              operands[2] = x27;
              x28 = XEXP (x21, 0);
              operands[1] = x28;
              if (!nvptx_register_operand (operands[1], E_SImode))
                return -1;
              x29 = XVECEXP (x24, 0, 0);
              if (!rtx_equal_p (x29, operands[2]))
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_DImode:
                  if (!nvptx_register_operand (operands[2], E_DImode))
                    return -1;
                  return 601; /* *p unpackdisi2 */

                case E_DFmode:
                  if (!nvptx_register_operand (operands[2], E_DFmode))
                    return -1;
                  return 602; /* *p unpackdfsi2 */

                default:
                  return -1;
                }

            case UNSPEC_VOLATILE:
              switch (XVECLEN (x22, 0))
                {
                case 4:
                  if (XINT (x22, 1) != 1)
                    return -1;
                  x24 = XEXP (x21, 1);
                  if (GET_CODE (x24) != UNSPEC_VOLATILE
                      || XVECLEN (x24, 0) != 1
                      || XINT (x24, 1) != 1)
                    return -1;
                  x29 = XVECEXP (x24, 0, 0);
                  if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  operands[5] = x17;
                  operands[6] = x19;
                  operands[7] = x18;
                  x26 = XEXP (x20, 0);
                  operands[0] = x26;
                  x27 = XVECEXP (x22, 0, 0);
                  operands[1] = x27;
                  x23 = XVECEXP (x22, 0, 1);
                  operands[2] = x23;
                  x30 = XVECEXP (x22, 0, 2);
                  operands[3] = x30;
                  x31 = XVECEXP (x22, 0, 3);
                  operands[4] = x31;
                  if (!const_int_operand (operands[4], E_SImode))
                    return -1;
                  x28 = XEXP (x21, 0);
                  if (!rtx_equal_p (x28, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern73 (x16, E_SImode) != 0)
                        return -1;
                      return 605; /* *p atomic_compare_and_swapsi_1 */

                    case E_DImode:
                      if (pattern73 (x16, E_DImode) != 0)
                        return -1;
                      return 606; /* *p atomic_compare_and_swapdi_1 */

                    default:
                      return -1;
                    }

                case 2:
                  operands[4] = x17;
                  operands[5] = x19;
                  operands[6] = x18;
                  x23 = XVECEXP (x22, 0, 1);
                  operands[3] = x23;
                  if (!const_int_operand (operands[3], E_SImode))
                    return -1;
                  switch (XINT (x22, 1))
                    {
                    case 2:
                      x26 = XEXP (x20, 0);
                      operands[0] = x26;
                      x27 = XVECEXP (x22, 0, 0);
                      operands[1] = x27;
                      x24 = XEXP (x21, 1);
                      operands[2] = x24;
                      x28 = XEXP (x21, 0);
                      if (!rtx_equal_p (x28, operands[1]))
                        return -1;
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern72 (x22, E_SImode) != 0)
                            return -1;
                          return 607; /* *p atomic_exchangesi */

                        case E_DImode:
                          if (pattern72 (x22, E_DImode) != 0)
                            return -1;
                          return 608; /* *p atomic_exchangedi */

                        default:
                          return -1;
                        }

                    case 0:
                      x26 = XEXP (x20, 0);
                      operands[1] = x26;
                      x28 = XEXP (x21, 0);
                      operands[0] = x28;
                      x24 = XEXP (x21, 1);
                      if (!rtx_equal_p (x24, operands[1]))
                        return -1;
                      x27 = XVECEXP (x22, 0, 0);
                      switch (GET_CODE (x27))
                        {
                        case PLUS:
                          x32 = XEXP (x27, 1);
                          operands[2] = x32;
                          x33 = XEXP (x27, 0);
                          if (!rtx_equal_p (x33, operands[1]))
                            return -1;
                          switch (GET_MODE (operands[1]))
                            {
                            case E_SImode:
                              if (pattern70 (x22, E_SImode) != 0)
                                return -1;
                              return 609; /* *p atomic_fetch_addsi */

                            case E_DImode:
                              if (pattern70 (x22, E_DImode) != 0)
                                return -1;
                              return 610; /* *p atomic_fetch_adddi */

                            case E_SFmode:
                              if (pattern70 (x22, E_SFmode) != 0)
                                return -1;
                              return 611; /* *p atomic_fetch_addsf */

                            default:
                              return -1;
                            }

                        case AND:
                          switch (pattern71 (x22))
                            {
                            case 0:
                              return 612; /* *p atomic_fetch_andsi */

                            case 1:
                              if (!
#line 1860 "../../gcc/config/nvptx/nvptx.md"
(DImode == SImode || TARGET_SM35))
                                return -1;
                              return 615; /* *p atomic_fetch_anddi */

                            default:
                              return -1;
                            }

                        case IOR:
                          switch (pattern71 (x22))
                            {
                            case 0:
                              return 613; /* *p atomic_fetch_orsi */

                            case 1:
                              if (!
#line 1860 "../../gcc/config/nvptx/nvptx.md"
(DImode == SImode || TARGET_SM35))
                                return -1;
                              return 616; /* *p atomic_fetch_ordi */

                            default:
                              return -1;
                            }

                        case XOR:
                          switch (pattern71 (x22))
                            {
                            case 0:
                              return 614; /* *p atomic_fetch_xorsi */

                            case 1:
                              if (!
#line 1860 "../../gcc/config/nvptx/nvptx.md"
(DImode == SImode || TARGET_SM35))
                                return -1;
                              return 617; /* *p atomic_fetch_xordi */

                            default:
                              return -1;
                            }

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CONST_INT:
          operands[0] = x17;
          operands[1] = x19;
          operands[2] = x18;
          switch (XWINT (x16, 0))
            {
            case 0L:
              return 585; /* *p nop */

            case 1L:
              return 586; /* *p exit */

            case 2L:
              return 587; /* *p fake_nop */

            default:
              return -1;
            }

        case UNSPEC:
          switch (pattern22 (x1))
            {
            case 0:
              if (!(
#line 1449 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SOFT_STACK) && 
#line 208 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode)))
                return -1;
              return 588; /* *p set_softstack_si */

            case 1:
              if (!(
#line 1449 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SOFT_STACK) && 
#line 208 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode)))
                return -1;
              return 589; /* *p set_softstack_di */

            default:
              return -1;
            }

        case TRAP_IF:
          x34 = XEXP (x16, 0);
          if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x35 = XEXP (x16, 1);
          if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[0] = x17;
          operands[1] = x19;
          operands[2] = x18;
          return 590; /* *p trap */

        case UNSPEC_VOLATILE:
          switch (pattern22 (x1))
            {
            case 0:
              if (!
#line 208 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
                return -1;
              return 598; /* *p omp_simt_exit_si */

            case 1:
              if (!
#line 208 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
                return -1;
              return 599; /* *p omp_simt_exit_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != CONST
      || GET_MODE (x2) != E_DImode)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_DImode)
    return NULL;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!nvptx_register_operand (operands[0], E_DImode))
    return NULL;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!symbol_ref_function_operand (operands[1], E_DImode))
    return NULL;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return NULL;
  return gen_split_1 (insn, operands);
}

rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  return NULL;
}
